《经典图论算法》贝尔曼-福特算法(Bellman-Ford)

摘要:

1,Bellman-Ford 算法的介绍

2,Bellman-Ford 算法为什么可以解决有负权边的图

3,Bellman-Ford 算法为什么不能解决有负权回路的图

4,Bellman-Ford 算法的代码实现和负权回路的判断

5,Bellman-Ford 算法的代码优化

1,Bellman-Ford算法的介绍

贝尔曼-福特算法(Bellman-Ford algorithm)和迪杰斯特拉算法(Dijkstra)一样也是求单源点最短路径的,但Dijkstra算法不能解决有负权边的图,如果想要解决有负权边的图可以使用 Bellman-Ford 算法。

解题思路就是假设有一条边 begin,end,value ,如果 disbegin + value < disend ,我们可以更新 disend 的值为 disbegin + value ,如下图所示,0 到 2 的距离如果经过顶点 1 会更小。

所以我们只需要枚举所有的边即可,代码如下:

go 复制代码
for (int[] edge : edges) {// 遍历边。
    int begin = edge[0];// 边的起点。
    int end = edge[1];// 边的终点。
    int value = edge[2];// 边的权值。
    if (dis[begin] + value < dis[end])// 松弛。
        dis[end] = dis[begin] + value;
}

如果只枚举一遍的话,有可能只会更新和起始点邻接的点(也就是起始点直接指向的点),与起始点没有邻接的点可能没更新,也可能更新了,这个和边的更新顺序有关,如下图所示。

也就是说如果枚举一遍,至少可以更新从起始点通过一条边到达的点,枚举两遍至少可以更新从起始点通过两条边到达的点 ...... 。在一个含有 n 个顶点的图中,一个点最多只能有 n-1 条边和起始点相连。所以我们最多只需要枚举 n-1 次即可计算从起始点到其他所有点的距离。

相关推荐
wanderist.2 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.2 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_307779132 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂2 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年3 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO93 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude3 小时前
c语言:递归
java·c语言·算法
edtoplort4 小时前
OpenAI紧急叫停GPT-6.1 Astra训练,奥尔特曼为何踩刹车
人工智能·gpt·算法
蒜香可达鸭4 小时前
让视频生成流水线跑不崩:一个事件溯源的多 Agent 可靠执行框架
算法
小羊没烦恼!5 小时前
系统内部模块(子系统)之间的耦合以及模块(子系统)划分
java·开发语言·前端·数据库·算法·c#